VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form FrmLogoAdd 
   Caption         =   " Logo Manager"
   ClientHeight    =   5880
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   7605
   Icon            =   "FrmBlob.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5880
   ScaleWidth      =   7605
   StartUpPosition =   1  'CenterOwner
   Begin MSComctlLib.ListView ListView 
      Height          =   3015
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   7335
      _ExtentX        =   12938
      _ExtentY        =   5318
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      PictureAlignment=   3
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSComDlg.CommonDialog DlgDB 
      Left            =   2280
      Top             =   3240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox TxtDBPath 
      Enabled         =   0   'False
      Height          =   285
      Left            =   2040
      TabIndex        =   5
      Top             =   4080
      Width           =   5535
   End
   Begin VB.TextBox TxtTableName 
      Height          =   285
      Left            =   2040
      TabIndex        =   3
      Text            =   "TblBlob"
      Top             =   4440
      Width           =   3495
   End
   Begin VB.CommandButton CmdClose 
      Caption         =   "3. Close       "
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   5400
      Width           =   1335
   End
   Begin VB.CommandButton CmdLogoDB 
      Caption         =   "1. Select DB"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   3240
      Width           =   1335
   End
   Begin VB.CommandButton CmdAddLogo 
      Caption         =   "2. Add Logo "
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   4920
      Width           =   1335
   End
   Begin MSComDlg.CommonDialog DlgLogo 
      Left            =   1680
      Top             =   3240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label4 
      Caption         =   "DB Path-Name"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   4080
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Table Name"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   4440
      Width           =   1815
   End
End
Attribute VB_Name = "FrmLogoAdd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Const MAX_PATH = 260

Private pobjConn As adodb.Connection
Public objRst As adodb.Recordset

Public pstrDBPath As String
Public pstrTableName As String


Private Const BLOCK_SIZE = 10000

Private Sub CmdLogoDB_Click()
    DlgDB.Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly Or cdlOFNExplorer
    DlgDB.CancelError = True
    DlgDB.Filter = "Databases|*.mdb"

    On Error Resume Next
    DlgDB.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & " selecting file." & vbCrLf & Err.Description
        Exit Sub
    End If
    pstrDBPath = DlgDB.FileName
    TxtDBPath.Text = pstrDBPath
End Sub

Public Sub Connection()
  ' Open the database connection.
  Set pobjConn = New adodb.Connection
  Set objRst = New adodb.Recordset
  pobjConn.Provider = "Microsoft.Jet.OLEDB.4.0"
  pobjConn.Properties("Data Source") = pstrDBPath
  pobjConn.Open
End Sub

Private Sub CmdAddLogo_Click()
Dim objRst As adodb.Recordset
Dim file_num As String
Dim file_length As String
Dim bytes() As Byte
Dim num_blocks As Long
Dim left_over As Long
Dim block_num As Long
Dim booAnswer As Boolean
On Error GoTo Oops:

    booAnswer = MsgBox("Adding a new logo to the database will erase any existing logos" & Chr(13) & "Do you want to proceed?", vbInformation + vbYesNo)
    If booAnswer = vbNo Then
      Exit Sub
    End If
      
    pstrTableName = Me.TxtTableName
   
    Call Connection
    'Delete any existing logos on the database
    Set objRst = pobjConn.Execute("Delete * FROM " & pstrTableName & "")
    
    
    DlgLogo.Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly Or cdlOFNExplorer
    DlgLogo.CancelError = True
    DlgLogo.Filter = "Graphics Files|*.bmp;*.ico;*.jpg;*.gif"

On Error Resume Next
    DlgLogo.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & " selecting file." & vbCrLf & Err.Description
        Exit Sub
    End If

On Error GoTo Oops:

    'Open the picture file.
    file_num = FreeFile
    
    Open DlgLogo.FileName For Binary Access Read As #file_num
    file_length = LOF(file_num)
    If file_length > 0 Then
    
        num_blocks = file_length / BLOCK_SIZE
        left_over = file_length Mod BLOCK_SIZE

        Set objRst = New adodb.Recordset
        objRst.CursorType = adOpenKeyset
        objRst.LockType = adLockOptimistic
        objRst.Open "Select * FROM " & pstrTableName & "", pobjConn

        objRst.AddNew
        objRst!PrefLogoLength = file_length
        
        ReDim bytes(BLOCK_SIZE)
        For block_num = 1 To num_blocks
            Get #file_num, , bytes()
            objRst!PrefLogo.AppendChunk bytes()
        Next block_num

        If left_over > 0 Then
            ReDim bytes(left_over)
            Get #file_num, , bytes()
            objRst!PrefLogo.AppendChunk bytes()
        End If

        objRst.Update
        Close #file_num

    End If

  'Display added logo to make sure it works
  Call CmdFetchLogo_Click
  
Oops:
  Select Case Err.Number
    Case 0
    
    Case 3265
      MsgBox "The " & pstrTableName & " table is missing one ore more fields." & vbCrLf & " Make sure the following fields exist on " & pstrTableName & " table." & vbCrLf & vbCrLf & "   PrefLogo - An OLE Object Data Type field" & vbCrLf & "   PrefLogoLength - A Number Data Type field set to Long Integer", vbInformation
    Case -2147217843
      MsgBox "Please select a DB to proceed", vbInformation
    Case -2147217865
      MsgBox "The Table you have entered does not exist on the DB" & vbCrLf & "If you have not done it yet, create a Table that MUST have the following fields:" & vbCrLf & vbCrLf & "   PrefLogo - An OLE Object Data Type field" & vbCrLf & "   PrefLogoLength - A Number Data Type field set to Long Integer", vbInformation
    Case -2147467259
      MsgBox "The Table " & pstrTableName & " is currently opened (locked)" & vbCrLf & "Please close it to proceed", vbInformation
    Case Else
      MsgBox "Error " & Format$(Err.Number) & vbCrLf & Err.Description
  End Select
  
End Sub

' Return a temporary file name.
Private Function TemporaryFileName() As String
Dim temp_path As String
Dim temp_file As String
Dim length As Long

    ' Get the temporary file path.
    temp_path = Space$(MAX_PATH)
    length = GetTempPath(MAX_PATH, temp_path)
    temp_path = Left$(temp_path, length)

    ' Get the file name.
    temp_file = Space$(MAX_PATH)
    GetTempFileName temp_path, "per", 0, temp_file
    TemporaryFileName = Left$(temp_file, InStr(temp_file, Chr$(0)) - 1)
End Function

Private Sub CmdFetchLogo_Click()
Dim objRst As adodb.Recordset
Dim bytes() As Byte
Dim file_name As String
Dim file_num As Integer
Dim file_length As Long
Dim num_blocks As Long
Dim left_over As Long
Dim block_num As Long
Dim hgt As Single
On Error Resume Next

    Screen.MousePointer = vbHourglass
    DoEvents

    ' Get the record.
    Set objRst = pobjConn.Execute("SELECT * FROM " & pstrTableName & "", , adCmdText)
    If objRst.EOF Then Exit Sub

    objRst.MoveFirst
    ' Get a temporary file name.
    file_name = TemporaryFileName()

    ' Open the file.
    file_num = FreeFile
    Open file_name For Binary As #file_num

    ' Copy the data into the file.
    file_length = objRst!PrefLogoLength
    num_blocks = file_length / BLOCK_SIZE
    left_over = file_length Mod BLOCK_SIZE

    For block_num = 1 To num_blocks
        bytes() = objRst!PrefLogo.GetChunk(BLOCK_SIZE)
        Put #file_num, , bytes()
    Next block_num

    If left_over > 0 Then
        bytes() = objRst!PrefLogo.GetChunk(left_over)
        Put #file_num, , bytes()
    End If

    Close #file_num

    ' Display the picture file.
    ListView.Picture = LoadPicture(file_name)

    Kill file_name
    Screen.MousePointer = vbDefault
End Sub

Private Sub CmdClose_Click()
  End
End Sub
